
;|
;|  Titel....: Basis Mathematik
;|  Datei....: Math.pbi
;|  Datum....: 02.09.2008
;|  Inhalt...: * Proceduren fr einfache Mathematische Berechungen
;|________________________________________________________________________________________________




;  Vorrausgesetzte Includes
;




;  Konstanten
;

 #PI2  = #PI*2
 #PI05 = #PI/2
 #E    = 2.718281828459045
 #SQR2 = 1.414213562373095
 #SQR3 = 1.732050807568877




;  Strukturen
;




;  Arrays und LinkedLists
;




;  Proceduren und Macros
;


 ; Berechnet das Quadrat einer Zahl
 Macro Qua(Value)
  ( (Value)*(Value) )
 EndMacro

 ; Berechnet das Kubik einer Zahl
 Macro Cub(Value)
  ( (Value)*(Value)*(Value) )
 EndMacro



 ; Korregiert einen Winkel in das Intervall Intervall [0,2PI[
 Procedure.f RealAngle2PI(Angle.f)
  Protected Result.f
  If Angle < 0
   Result.f = (Angle/#PI2-Int(Angle/#PI2)+1)*#PI2 
  Else
   Result.f = (Angle/#PI2-Int(Angle/#PI2))*#PI2 
  EndIf
  ProcedureReturn Result
 EndProcedure
 
 ; Korregiert einen Winkel in das Intervall Intervall [0,360[
 Procedure.f RealAngle360(Angle.f)
  Protected Result.f
  If Angle < 0
   Result.f = (Angle/360-Int(Angle/360)+1)*360 
  Else
   Result.f = (Angle/360-Int(Angle/360))*360 
  EndIf
  ProcedureReturn Result
 EndProcedure
 
 
 
 ; Berechnet die Fakultt einer Zahl
 Procedure Factorial(Value)
  Protected n, Factorial = 1
  For n = 2 To Value
   Factorial * n
  Next n
  ProcedureReturn Factorial
 EndProcedure
 
 ; Modulo
 Macro Mod(Value, Factor)
  ( Value-Int(Value/Factor)*Factor )
 EndMacro
  
 ; Signum
 Procedure Sgn(Value.f)
  If Value > 0
   ProcedureReturn 1
  ElseIf Value < 0
   ProcedureReturn -1
  Else 
   ProcedureReturn 0
  EndIf
 EndProcedure

 
 
 ; Berechnet die Diagonale
 Macro Diagonal(x, y)
  Sqr( Qua(x)+Qua(y) )
 EndMacro
 
 ; Berechnet die Diagonale zum Quadrat
 Macro DiagonalQua(x, y)
  ( Qua(x)+Qua(y) )
 EndMacro
 
 
 
 ; Berechnet den Winkel
 Procedure.d Angle(x.d,y.d)
  Protected Angle.d
  Angle = ATan(y/x)
  If x < 0 : Angle + #PI : EndIf 
  ProcedureReturn Angle
 EndProcedure
 
 
 
 ; mathematische Summe von .. bis .. ber ..
 Macro Total(Unten, Oben, Innen)
  Macro_TotalReturn = 0
  For Unten To Oben
   Macro_TotalReturn + Innen
  Next
 EndMacro
 Macro TotalReturn()
  Macro_TotalReturn
 EndMacro
 
 
 
 ; Berechnet den Abstand zwischen zwei Punkte
 Macro Distance(x1, y1, x2, y2)
  Sqr( Qua((x1)-(x2)) + Qua((y1)-(y2)) )
 EndMacro
 
 
 
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 145
; FirstLine = 108
; Folding = ---