
;|
;|  Titel....: Mouse
;|  Datei....: Mouse.pbi
;|  Datum....: 01.09.2008
;|  Inhalt...: * Erweiterung der Mausabfrage-Proceduren
;|              - Window und Screen
;|              - Aktionen wie Klicks und Druckzeiten
;|_____________________________________________________________________________




;  Vorrausgesetzte Includes
;




;  Konstanten
;

 ; ExamineMouse(Input)
 #Mouse_Window      = %00000001
 #Mouse_Screen      = %00000010

 ; MouseButtonEvent(Button)
 #Mouse_FirstDown   = %00000001
 #Mouse_Down        = %00000010
 #Mouse_LongDown    = %00000100
 #Mouse_StepDown    = %00001000
 #Mouse_Click       = %00010000
 #Mouse_DoubleClick = %00100000

 ; MouseEvent()
 #Mouse_Move        = %00000000
 #Mouse_TinyStop    = %00000001
 #Mouse_Stop        = %00000010
 #Mouse_LongStop    = %00000100




;  Strukturen
;

 ; Verwantung der Ereignisse
 Structure MousePBI
  DownTime.l
  Click.b
  Pause.b
  Event.b
 EndStructure




;  Arrays und LinkedLists
;

 ; Verwantung der Ereignisse
 Global Dim MousePBI.MousePBI(3)




;  Proceduren und Macros
;

 ; Neue Procedure zum Auswerten der Ereignisse
 Procedure ExamineMousePBI(Input) 
  Protected Button, MouseButton 
  If Input = #Mouse_Screen
   ExamineMouse()
  EndIf
  With MousePBI(0)
   If MouseDeltaX() Or MouseDeltaY() 
    \DownTime = 0
   Else
    \DownTime + 1
   EndIf
   \Event = 0
   If \DownTime =   0 : \Event | #Mouse_Move     : EndIf
   If \DownTime <= 20 : \Event | #Mouse_TinyStop : EndIf
   If \DownTime >  20 : \Event | #Mouse_Stop     : EndIf
   If \DownTime >  60 : \Event | #Mouse_LongStop : EndIf
  EndWith
  For Button = 1 To 3
   If Input = #Mouse_Screen
    MouseButton = MouseButton(Button)
   Else
    MouseButton = GetAsyncKeyState_(Button)
   EndIf
   With MousePBI(Button)
    If \Pause > 0 :
     \Pause - 1
    EndIf
    If MouseButton
     \DownTime + 1
    Else
     If \DownTime > 1 :
      If \Pause > 0 :
       \Click = 2
      Else      
       \Click = 1
      EndIf
      \Pause = 20
     Else 
      \Click = 0
     EndIf
    EndIf
    \Event = 0
    If \DownTime = 1  : \Event | #Mouse_FirstDown   : EndIf
    If \DownTime > 0  : \Event | #Mouse_Down        : EndIf
    If \DownTime > 20 : \Event | #Mouse_LongDown    
     If \DownTime % 4 : \Event | #Mouse_StepDown    : EndIf
    EndIf
    If \Click > 0     : \Event | #Mouse_Click       : EndIf
    If \Click = 2     : \Event | #Mouse_DoubleClick : EndIf 
    If Not MouseButton
     \DownTime = 0 
    EndIf
   EndWith
  Next Button 
 EndProcedure
 
 ; Aktualisiert den Maus-Status
 Macro ExamineMouse(Input=#Mouse_Screen)
  ExamineMousePBI(Input)
 EndMacro
 
 ; Gibt eine kombination von Aktionen des Mausbuttons zurck
 Macro MouseButtonEvent(Button)
  MousePBI(Button)\Event
 EndMacro
 
 ; Gibt die aktuelle Aktion der Maus zurck
 Macro MouseEvent()
  MousePBI(0)\Event 
 EndMacro
 
 ; Ermittelt ob die Mause innerhalb einer Box ist
 Procedure IsMouseInBox(x, y, Width, Height)
  If Width < 0 : x+Width : Width = -Width : EndIf
  If Height < 0 : y+Height : Height = -Height : EndIf
  If MouseX() > x And MouseX() < x+Width And MouseY() > y And MouseY() < y+Height
   ProcedureReturn #True
  EndIf
 EndProcedure

; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 148
; Folding = --