

IncludePath ""
 XIncludeFile "PathFind.pbi"
 XIncludeFile "Mouse.pbi"


OnErrorGoto(?ErrorHandler)


InitSprite()
InitMouse()
InitKeyboard()

OpenWindow(0, 0, 0, 800, 600, "Fenster", #PB_Window_SystemMenu);|#PB_Window_ScreenCentered
OpenWindowedScreen(WindowID(0), 0, 0, 800, 600, 0, 0, 0)


Mouse.Point2D
SaveMouse.Point2D
AltPunkt.Point2D

; Start und Ziel
SetPoint2D(Start.Point2D,  50,  340)
SetPoint2D(Ziel.Point2D,  750, 340)

AddWallBox(10, 80, 780, 510)

*MyPath.PathTree = FindPath(Start, Ziel)

Repeat

 ClearScreen(0)
 
 StartDrawing(ScreenOutput())

  DrawingMode(1)
  
  ; Start und Ziel
  Circle(Start\x, Start\y, 4, $00A0A0)
  DrawText(Start\x-TextWidth("Start")/2, Start\y+5, "Start", $00A0A0)
  Circle(Ziel\x, Ziel\y, 4, $00A000)
  DrawText(Ziel\x-TextWidth("Ziel")/2, Ziel\y+5, "Ziel", $00A000)
  
  ; Wnde anzeigen
  FrontColor(RGB(128,128,255))
  ForEach Wall() : With Wall()
   DrawLine2D(Wall())
  EndWith : Next
  
  ; Weg anzeigen 
  FrontColor(RGB(255,255,0))
  Status = ExaminePath(*MyPath)
  If Status = #PathFind_Successful
   DrawText(5, 5, "Weg erfolgreich berechnet", $40D040)
   DrawText(10, 25, "Kollisionskontrollen : "+Str(GetCheckPaths(*MyPath)), $808080)
   DrawText(10, 40, "Weg-Knoten : "+Str(GetNodes(*MyPath)), $808080)
   DrawText(10, 55, "Berechungszeit : "+Str(GetPathFindTime(*MyPath))+"ms", $808080)
   CopyVector2D(*MyPath\Start, AltPunkt)
   While NextPathPoint(*MyPath)
    *Punkt.Point2D = GetPathPoint(*MyPath)
    LineXY(AltPunkt\x, AltPunkt\y, *Punkt\x, *Punkt\y)
    CopyVector2D(*Punkt, AltPunkt)
   Wend
  ElseIf Status = #PathFind_Calculate
   DrawText(5, 5, "Weg wird berechnet ...", $40D0D0)
  ElseIf Status = #PathFind_Reachable
   DrawText(5, 5, "Das Ziel ist unerreichbar", $4040D0)
  EndIf
  
  ; Hinweise
  DrawText(500, 10, "Direkte-Wegsuche  2008 Martin Guttmann", $4080D0)
  DrawText(500, 30, "Mauer setzen mit linker Maus", $4080D0)
  DrawText(500, 50, "Start/Ziel verschieben mit rechter Maus", $4080D0)
 
  ; Maus
  If View
   LineXY(SaveMouse\x, SaveMouse\y, Mouse\x, Mouse\y, $FFFF00)
  EndIf
  Line(Mouse\x, Mouse\y, 7, 15, $FFFFFF)
  Line(Mouse\x, Mouse\y, 15, 7, $FFFFFF)

 StopDrawing()
 
 FlipBuffers()

 Delay(10)
 WindowEvent()
 
 ExamineKeyboard()
 If KeyboardPushed(#PB_Key_Escape)
  End
 EndIf
 If KeyboardReleased(#PB_Key_F12)
  GrabSprite(1, 0, 0, 800, 600)
  SaveSprite(1, "Screen.bmp")
 EndIf
 If KeyboardReleased(#PB_Key_F5)
  If CreateFile(1, "PathFindLog.txt")
   WriteData(1, Start, 8)
   WriteData(1, Ziel, 8)
   ForEach Wall()
    WriteData(1, Wall(), 32)
   Next
   CloseFile(1)
  EndIf
 EndIf
 If KeyboardReleased(#PB_Key_F6)
  If ReadFile(1, "PathFindLog.txt")
   ReadData(1, Start, 8) 
   ReadData(1, Ziel, 8) 
   ClearList(Wall())
   While Not Eof(1)
    AddElement(Wall())
    ReadData(1, Wall(), 32) 
   Wend
   CloseFile(1)
   FreePath(*MyPath)
   *MyPath = FindPath(Start, Ziel)
  EndIf
 EndIf
 
 ExamineMouse()
 SetPoint2D(Mouse, MouseX(), MouseY())
 
 ; Start/Ziel verschieben
 If MouseButtonEvent(2) & #Mouse_FirstDown
  If Distance2D(Mouse, Start) < 10
   *Schieben.Point2D = @Start
  ElseIf Distance2D(Mouse, Ziel) < 10
   *Schieben.Point2D = @Ziel
  Else 
   *Schieben = 0
  EndIf
 ElseIf MouseButtonEvent(2) & #Mouse_Click 
  FreePath(*MyPath)
  *MyPath = FindPath(Start, Ziel) 
 ElseIf MouseButtonEvent(2) & #Mouse_Down And *Schieben
  CopyPoint2D(Mouse, *Schieben)
 EndIf 

 ; Mauer setzen
 If MouseButtonEvent(1) & #Mouse_FirstDown
  View = #True
  CopyPoint2D(Mouse, SaveMouse)
 ElseIf MouseButtonEvent(1) & #Mouse_Click
  AddWallXY(SaveMouse\x, SaveMouse\y, Mouse\x, Mouse\y)
;  AddWallBox(SaveMouse\x, SaveMouse\y, Mouse\x-SaveMouse\x, Mouse\y-SaveMouse\y)
  FreePath(*MyPath)
  *MyPath = FindPath(Start, Ziel)
 ElseIf Not MouseButtonEvent(1)
  View = #False
 EndIf
  
ForEver


ErrorHandler:
 Text1$ = "Typ: "+GetErrorDescription()
 Text2$ = "File: "+GetErrorModuleName() + "   Line: "+Str(GetErrorLineNR())
 Text3$ = "Memory: "+Str(GetErrorAddress())
 MessageRequester("Fehler", Text1$+#LF$+Text2$+#LF$+Text3$) 
End

; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 53
; FirstLine = 32
; Folding = -
; EnableThread
; EnableOnError
; Executable = PathFind3.exe
; DisableDebugger